﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Infragistics.Excel;
using System.Diagnostics;

namespace WindowsFormsApplication11
{
    public partial class Form1 : Form
    {
        DataTable dt = new DataTable();
        string fileName;

        public Form1()
        {
            InitializeComponent();

            dt.Columns.Add("Date", typeof(DateTime));

            dt.Rows.Add(new object[] { DateTime.Now });
            dt.Rows.Add(new object[] { DateTime.Today });
            dt.AcceptChanges();

            this.fileName = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "test.xlsx");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Workbook workBook = new Workbook(WorkbookFormat.Excel2007);
            Worksheet worksheet = workBook.Worksheets.Add("Worksheet1");

            int rowIndex = 0;
            foreach (DataRow datarow in dt.Rows)
            {
                for (int columnIndex = 0; columnIndex < datarow.ItemArray.Length; columnIndex++)
                {
                    worksheet.Rows[rowIndex].Cells[columnIndex].Value = datarow[columnIndex];                    
                }
                rowIndex++;
            }

            // Save xlsx excel file
            // ---------------------
            // Export DateTime column is ok, it  has the right format like dd/mm/yyyy (French culture)
            // ---------------------
            workBook.Save(fileName);

            Process.Start(fileName);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Workbook workBook = Workbook.Load(fileName);


            // Remove the worksheetName
            workBook.Worksheets.Remove(workBook.Worksheets["Worksheet1"]);


            Worksheet worksheet = workBook.Worksheets.Add("Worksheet1");

            int rowIndex = 0;
            foreach (DataRow datarow in dt.Rows)
            {
                for (int columnIndex = 0; columnIndex < datarow.ItemArray.Length; columnIndex++)
                {
                    worksheet.Rows[rowIndex].Cells[columnIndex].Value = datarow[columnIndex];
                }
                rowIndex++;
            }

            // Save xlsx excel file
            // ---------------------
            // Now, export DateTime column is ok but it  has a wrong  format like 39976
            // ---------------------
            workBook.Save(fileName);
            Process.Start(fileName);
        }
    }
}
